Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa04w.bas                                                               *
'*                                                                           *
'* aISA-P04W/H                                                           *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/05/01                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA04_DLL_NAME = "aisa04.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const AISA04_MAX_PORT_W = 16   ' aISA-P04W̃|[g
Global Const AISA04_MAX_PORT_H = 8    ' aISA-P04H̃|[g

Global Const AISA04_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    aisa04.dll[h                                                 *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa04wDllOpen() As Boolean
    
    Aisa04wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AISA04_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Aisa04wGetDllExportFunc() = False Then
        Aisa04wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Aisa04wDllOpen = True

End Function

'*****************************************************************************
'*    aisa04.dllA[h                                             *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa04wDllClose() As Boolean

    Aisa04wDllClose = True
    
    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa04wDllClose = False

End Function

'*****************************************************************************
'*    aISA-P04W/H DLL,Driver̃o[Wԍ擾                         *
'*    pdwDll DLLo[Wԍi[                                     *
'*        pdwDrv Drvo[Wԍi[                                     *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa04wGetVersion(pdwDll As Long, pdwDrv As Long) As Boolean
    
    Aisa04wGetVersion = False
    
    If hDLL = 0 Then Exit Function
    
    If Aisa04GetVersion(pdwDll, pdwDrv) = 0 Then Exit Function
        
    Aisa04wGetVersion = True

End Function

'*****************************************************************************
'*    aISA-P04W/H̔Cӂ̃foCX̎gp錾                            *
'*    pwLogSlot  gpfoCXi[AhX                      *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa04wCreate(pwLogSlot As Integer) As Boolean

    Aisa04wCreate = False

    If hDLL = 0 Then Exit Function

    If Aisa04Create(pwLogSlot) = 0 Then Exit Function
    
    Aisa04wCreate = True

End Function

'*****************************************************************************
'*    aISA-P04W/H̔Cӂ̃foCX̎gpJ                            *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa04wClose(wLogSlot As Integer) As Boolean

    Aisa04wClose = False
    
    If hDLL = 0 Then Exit Function

    If Aisa04Close(wLogSlot) = 0 Then Exit Function
    
    Aisa04wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pres     \[Xi[\̂̃AhX                    *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa04wGetResource(wLogSlot As Integer, pres As AISA04RESOURCE) As Boolean
    
    Aisa04wGetResource = False
    
    If hDLL = 0 Then Exit Function

    If Aisa04GetResource(wLogSlot, pres) = 0 Then Exit Function
    
    Aisa04wGetResource = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gf[^                                       *
'*    wLogSlot ͂foCX                                          *
'*        dwPort   ͂|[g                                            *
'*        pbValue  ̓f[^i[                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa04wInPort(wLogSlot As Integer, dwPort As Long, pbValue As Byte) As Boolean
    
    Aisa04wInPort = False
    
    If hDLL = 0 Then Exit Function

    If Aisa04InPort(wLogSlot, dwPort, pbValue) = 0 Then Exit Function
    
    Aisa04wInPort = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gփf[^o                                         *
'*    wLogSlot o͂foCX                                          *
'*        dwPort   o͂|[g                                            *
'*        bValue   o͂f[^                                            *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa04wOutPort(wLogSlot As Integer, dwPort As Long, bValue As Byte) As Boolean
    
    Aisa04wOutPort = False
    
    If hDLL = 0 Then Exit Function

    If Aisa04OutPort(wLogSlot, dwPort, bValue) = 0 Then Exit Function
    
    Aisa04wOutPort = True

End Function

'*****************************************************************************
'*    aISA-P04W/H̃G[R[h                                          *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Aisa04wGetLastError(wLogSlot As Integer) As Long
    
    Aisa04wGetLastError = AISA04_ERR_WRAPDLL
    
    If hDLL = 0 Then Exit Function

    Aisa04wGetLastError = Aisa04GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Aisa04wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    
    Aisa04wGetDllExportFunc = False
    
    ' Aisa04GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa04GetVersion")
    If pFunc = 0 Then Exit Function

    ' Aisa04Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa04Create")
    If pFunc = 0 Then Exit Function
    
    ' Aisa04Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa04Close")
    If pFunc = 0 Then Exit Function

    ' Aisa04GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa04GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa04InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa04InPort")
    If pFunc = 0 Then Exit Function
    
    ' Aisa04OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa04OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa04GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa04GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa04wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function

